#include "XBP.CH"
#include "APPEVENT.CH"
#include "GRA.CH"
#include "XBPDEV.CH"

PROCEDURE APPSYS
RETURN

PROCEDURE MAIN
LOCAL nEvent := 0, mp1 := 0, mp2 := 0, oXbp
LOCAL nRed := 0, nGreen := 0, nBlue := 0
LOCAL oDlg
LOCAL oSlideRed
LOCAL oSlideGreen
LOCAL oSlideBlue
LOCAL oStatic
LOCAL oVert1,oVert2,oVert3
LOCAL bCallback
LOCAL aScope
LOCAL oBitmap := XbpBitmap():New():Create()
LOCAL aPP := {}

   AADD(aPP,{XBP_PP_BGCLR,GRA_CLR_PINK})

   oDlg       := XbpDialog():new(AppDesktop() ,, {0,0}, {800,600},,.F. )
*  oDlg:title := "native Slider Demo"
   oDlg:Icon  := 1
   oDlg:tasklist  := .T.
   oDlg:MaxButton := .F.
   oDlg:clipChildren := .T.
   oDlg:DrawingArea:clipChildren := .T.
   oDlg:create()

   // show Color
   //
   oStatic := XbpStatic():new(oDlg:DrawingArea,,{100,400},{400,140})
   oStatic:create()


   // vertical
   //
   oVert1 := DXE_Slider():New(oDlg:DrawingArea,,{550,100},{40,400})
   oVert1:Orientation   := XBPPRN_ORIENT_PORTRAIT
   oVert1:Range         := {0,255}
*   oVert1:nBuddySpace   := 40
   oVert1:Drawmode      := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oVert1:PaintStyle    := "ECLIPSE"
   oVert1:ColorCHANNEL  := GRA_CLR_YELLOW
   oVert1:ColorTHUMB    := GRA_CLR_CYAN
   oVert1:ColorSCOPE    := GRA_CLR_CYAN
   oVert1:Create()
   //
*   oVert1:oBudTopLeft    :SetCaption("   Min")
*   oVert1:oBudBottomRight:SetCaption("   Max")


   oBitmap:Loadfile("WHITE_CYAN.BMP")
   // vertical
   //
   oVert2 := DXE_Slider():New(oDlg:DrawingArea,,{610,100},{40,400},{{XBP_PP_BGCLR,GRA_CLR_PINK}})
   oVert2:Orientation   := XBPPRN_ORIENT_PORTRAIT
*  oVert2:Range         := {0,255}
   oVert2:Range         := {-255,0}      // start on negative value
*  oVert2:Reversed      := .T.    // only Flag ?
*  oVert2:DownIsLeft    := .F.    // hm ... how does it work ?
   oVert2:nBuddySpace   := 40
   oVert2:Drawmode      := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oVert2:PaintStyle    := "DIAMOND"
*  oVert2:ColorCHANNEL  := XBPSYSCLR_3DFACE
   oVert2:ColorCHANNEL  := GraMakeRGBColor({153,253,254})
   oVert2:ColorGradient := GRA_CLR_BLUE
   oVert2:ColorTHUMB    := GRA_CLR_CYAN
   oVert2:ColorSCOPE    := XBPSYSCLR_ENTRYFIELD
   oVert2:oBitmap       := oBitmap
   oVert2:PosBoth       := .T.                     // Tick Marker both Side
   oVert2:Create()
   //
   // change Min/Max
   oVert2:oBudTopLeft    :SetCaption("   Max")
   oVert2:oBudBottomRight:SetCaption("   Min")


   oVert3 := DXE_Slider():New(oDlg:DrawingArea,,{670,100},{40,400})
   oVert3:Orientation   := XBPPRN_ORIENT_PORTRAIT
   oVert3:PosLeft       := .T.
   oVert3:Range         := {0,255}
   oVert3:Drawmode      := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oVert3:PaintStyle    := "VISUAL"
*  oVert3:ColorCHANNEL  := XBPSYSCLR_3DFACE
   oVert3:ColorCHANNEL  := GRA_CLR_CYAN
   oVert3:ColorGradient := GRA_CLR_BLUE
   oVert3:ColorTHUMB    := GRA_CLR_RED
   oVert3:ColorSCOPE    := GRA_CLR_BLUE
   oVert3:Create()


   // Red
   //
   oSlideRed   := DXE_Slider():New(oDlg:DrawingArea,,{100,100},{400,40})
   oSlideRed:Orientation   := XBPPRN_ORIENT_LANDSCAPE
   oSlideRed:Range         := {0,255}
   oSlideRed:Drawmode      := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oSlideRed:ColorCHANNEL  := GRA_CLR_RED
   oSlideRed:ColorSCOPE    := GRA_CLR_GREEN
*  oSlideRed:ColorTHUMB    := GRA_CLR_BLUE
*  oSlideRed:PaintStyle    := "ECLIPSE"
   oSlideRed:Create()
   //
   bCallback := {|mp1, mp2, oXbp| nRed   := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideRed:Track   := bCallback

   // Green
   //
   oSlideGreen := DXE_Slider():New(oDlg:DrawingArea,,{100,200},{400,40},{{XBP_PP_BGCLR,GraMakeRGBColor({153,255,153})}})
   oSlideGreen:Orientation    := XBPPRN_ORIENT_LANDSCAPE
   oSlideGreen:PosBoth        := .T.                     // Tick Marker both Side
   oSlideGreen:Range          := {0,255}
   oSlideGreen:nBuddySpace    := 40
   oSlideGreen:Drawmode       := XBP_DRAW_OWNERADVANCED
   oSlideGreen:NoThumb        := .T.
   oSlideGreen:ColorSCOPE     := GRA_CLR_GREEN
   oSlideGreen:ColorCHANNEL   := GRA_CLR_YELLOW
   oSlideGreen:Create()
   //
   oSlideGreen:oBudTopLeft    :SetCaption("Min")
   oSlideGreen:oBudBottomRight:SetCaption("Max")
   //
   bCallback := {|mp1, mp2, oXbp| nGreen := mp1 ,;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideGreen:Track := bCallback

   // Blue
   //
   oSlideBlue  := DXE_Slider():New(oDlg:DrawingArea,,{100,300},{400,40})
   oSlideBlue:Orientation  := XBPPRN_ORIENT_LANDSCAPE
   oSlideBlue:PosTop       := .T.
   oSlideBlue:Range        := {0,255}
   oSlideBlue:Drawmode     := XBP_DRAW_OWNERADVANCED
   oSlideBlue:ColorSCOPE   := GRA_CLR_BLUE
*  oSlideBlue:ColorCHANNEL := GRA_CLR_CYAN
   oSlideBlue:ColorTHUMB   := GRA_CLR_CYAN
   oSlideBlue:PaintStyle   := "ECLIPSE"
   oSlideBlue:Create()
   //
   bCallback := {|mp1, mp2, oXbp| nBlue  := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideBlue:Track  := bCallback

   CenterControl(oDlg)
   oDlg:setTitle( "native Slider Demo "+oSlideBlue:Version() )

   // mark Scope with Cursor Check when move
   //
   oVert1     :SetScope({050,200})
   oVert1     :SetScope({075,175})
   oSlideRed  :SetScope({050,185})
   oSlideGreen:SetScope({ 50,185})
   oSlideBlue :SetScope({101,200})

   // Set-/Get-Data as usual
   //
   aScope     := oSlideRed:GetScope()   ; oSlideRed  :SetData(INT(aScope[1]+((aScope[2]-aScope[1])/2)) )
   aScope     := oSlideGreen:GetScope() ; oSlideGreen:SetData(INT(aScope[1]+((aScope[2]-aScope[1])/2)) )
   aScope     := oSlideBlue:GetScope()  ; oSlideBlue :SetData(INT(aScope[1]+((aScope[2]-aScope[1])/2)) )
   aScope     := oVert1:GetScope()      ; oVert1     :SetData(INT(aScope[1]+((aScope[2]-aScope[1])/2)) )

   // default Ticks ( Marker ) 1
   //
   oVert1     :SetFrequency(20)
   oVert2     :SetFrequency(15)
   oVert3     :SetFrequency(20)
   oSlideRed  :SetFrequency(20)
   oSlideGreen:SetFrequency(15)
   oSlideBlue :SetFrequency(20)

   // lengh of Thumb -> high/wide of Channel
   //
*  oVert2:SetThumblength(30)

   oDlg:Show()
   ShowRGB( nRed, nGreen, nBlue ,oStatic)
   SetAppFocus(oSlideRed)

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE ShowRGB( nRed, nGreen, nBlue ,oStatic)
LOCAL oPS   := oStatic:lockPS() // presentation space
LOCAL aAttr := Array(GRA_AA_COUNT)        // area attributes
LOCAL aAStr := Array(GRA_AS_COUNT)        // string attributes
LOCAL nMax  := oPS:maxColorIndex()        // maximum colors
LOCAL aOldAttr
LOCAL aSize := oStatic:CurrentSize()

   // Set RGB color passed and draw box to
   // visualize it
   oPS:setColorIndex( nMax, {nRed,nGreen,nBlue} )

   aAttr[ GRA_AA_COLOR  ] := nMax
   aOldAttr := oPS:setAttrArea( aAttr )
   GraBox( oPS, {0,0}, aSize, GRA_FILL )
   oPS:setAttrArea( aOldAttr )

   aAStr[ GRA_AL_COLOR ] := XBPSYSCLR_WINDOWTEXT
   GraSetAttrString( oPS, aAStr )
   GraStringAt( oPS, {100, aSize[2]/2}, "R/G/B" + str(nRed)+str(nGreen)+str(nBlue) )

   oStatic:unlockPS()

RETURN

*
*
*